﻿using System;
//调用倍福Ads库中的内容
using TwinCAT.Ads;

namespace BeckhoffAdsTester2
{
    class Program
    {
        static void Main(string[] args)
        {
            //创建实例
            AdsClient tcClient = new AdsClient();
            uint varHandle = 0;
            uint valueToRead = 0;
            uint valueToWrite = 42;
            try
            {
                //连接851端口，AmsNetId这里如果是本地的话可不写，默认为本地，下方有另一种写法的演示
                tcClient.Connect(851);

                //人机交互信息
                Console.WriteLine(" R为PLC运行   S为PLC停止");
                Console.WriteLine("\r\n请选择R或者S来控制PLC的状态");
                string sInput = Console.ReadLine().ToLower();

                //根据用户的选择来执行PLC状态（如果选择R，PLC切换至运行模式；如果选择S，PLC停止；如果都不是，重复人机交互信息）
                do
                {
                    switch (sInput)
                    {
                        case "r": tcClient.WriteControl(new StateInfo(AdsState.Run, tcClient.ReadState().DeviceState)); break;
                        case "s": tcClient.WriteControl(new StateInfo(AdsState.Stop, tcClient.ReadState().DeviceState)); break;
                        default: Console.WriteLine("请选择R或者S来控制PLC的状态"); sInput = Console.ReadLine().ToLower(); break;
                    }
                } while (sInput != "r" && sInput != "s");
                tcClient.Connect(AmsNetId.Local, 851);
                varHandle = tcClient.CreateVariableHandle("MAIN.a");
                //client.WriteAny(varHandle, valueToWrite);
                valueToRead = (uint)tcClient.ReadAny(varHandle, typeof(uint));
                Console.WriteLine("读取到的变量值为：{0}", valueToRead);
            }

            catch (FormatException)
            {
                Console.WriteLine("发生了类型转换异常");
            }

            catch (OverflowException)
            {
                Console.WriteLine("发生了溢出异常");
            }

            catch (ArgumentException)
            {
                Console.WriteLine("发生了冲突");
            }

            //释放缓存
            finally
            {
                tcClient.Dispose();
                
            }
        }
    }
}
