﻿using System;
using TwinCAT.Ads;
using TwinCAT.TypeSystem;

namespace BeckhoffAdsTester4
{
    class Program
    {
        static void Main(string[] args)
        {
            //创建客户端实例类，连接851端口和AmsNetId，再声明需要读的变量
            AdsClient client = new AdsClient();
            client.Connect(AmsNetId.Local, 851); // 通过对应的AmsNetId连接到851端口

            // 将变量handle指向想要读取的变量
            uint handle1 = client.CreateVariableHandle("MAIN.s_value");
            uint handle2 = client.CreateVariableHandle("MAIN.s_valuewritten");

            try
            {
                // 大小设置为80字节(可大不可小)，实例化字节大小类，实例化强制转换类并读取数据
                int byteSize = 80; 
                byte[] buffer = new byte[byteSize];
                int readBytes1 = client.Read(handle1, buffer.AsMemory());
                PrimitiveTypeMarshaler converter = new PrimitiveTypeMarshaler(StringMarshaler.DefaultEncoding);
                
                //声明一个新的变量value，强制转换数据，并输出结果
                string value = null;
                converter.Unmarshal<string>(buffer.AsSpan(), out value);
                Console.WriteLine("读取到的字符串为：{0}", value);

                //实例化写入字节大小类，给予变量新的值，转换并写入
                byte[] writeBuffer = new byte[byteSize];
                value = "Hello TwinCAT";
                converter.Marshal(value, writeBuffer);
                client.Write(handle2, writeBuffer);
            }

            //捕捉错误代码
            catch(Exception err)
            {
                Console.WriteLine("{0}", err.Message);
            }

            //删除缓存
            finally
            {
                client.DeleteVariableHandle(handle1);
                client.DeleteVariableHandle(handle2);
            }
        }
    }
    
}
